//
//  ClubChatBuddyViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 05. 31.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatBuddyViewController.h"
#import "ClubChatBuddyTableCellViewController.h"
#import "ClubChatData.h"

@implementation ClubChatBuddyViewController

/*
 - (id)initWithStyle:(UITableViewStyle)style {
 // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 if (self = [super initWithStyle:style]) {
 }
 return self;
 }
 */

- (void)viewDidLoad {
    [super viewDidLoad];
	
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMsg:) name:@"receiveMsg" object:nil];
	[self.tableView setDataSource:self];
	
	chatterList=[[NSArray alloc] init];
	array=[[NSMutableArray alloc] init];
}

-(void)receiveMsg:(NSNotification *)notification{
	ClubChatData *data=(ClubChatData *)notification.object;
	if([data.header isEqualToString:@"/채터정보"]){
		NSLog(@"채터정보..");
		if(!chatterList){
			chatterList=[[NSArray alloc] initWithArray:data.array];
		}else{
			[chatterList release];
			chatterList=[[NSArray alloc] initWithArray:data.array];
		}
		
		[self.tableView reloadData];
	}
}

/*
 - (void)viewWillAppear:(BOOL)animated {
 [super viewWillAppear:animated];
 }
 */
/*
 - (void)viewDidAppear:(BOOL)animated {
 [super viewDidAppear:animated];
 }
 */
/*
 - (void)viewWillDisappear:(BOOL)animated {
 [super viewWillDisappear:animated];
 }
 */
 - (void)viewDidDisappear:(BOOL)animated {
	 [super viewDidDisappear:animated];
	 
	 //NSLog(@"ClubChatBuddyViewController viewDidDisappear");
	 
	 for(ClubChatBuddyTableCellViewController *controller in array){
		 [controller viewDidDisappear:animated];
	 }
 }

/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return chatterList.count;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	
	ClubChatBuddyTableCellViewController *controller;
	UIView *view;
	if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
		
		cell.selectionStyle=UITableViewCellSelectionStyleNone;
		//cell.accessoryAction
		
		UIFont *font=[UIFont systemFontOfSize:12.0f];
		cell.font=font;
		cell.image=[UIImage imageNamed:@"icon_basic.gif"];
		
		controller=[[ClubChatBuddyTableCellViewController alloc] initWithNibName:@"ClubChatBuddyTableCellViewController" bundle:nil];
		CGRect rect=[controller.view frame];
		[controller.view setFrame:CGRectMake(60.0,0.0,rect.size.width,rect.size.height)];
		[controller.view setTag:1];
		
		[cell.contentView addSubview:controller.view];
		[array addObject:controller];
		[controller release];
		
	}
    // Set up the cell...
	view=[cell viewWithTag:1];
	controller=(ClubChatBuddyTableCellViewController *)[view nextResponder];
	[controller setChatter:[chatterList objectAtIndex:indexPath.row]];
	
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
	
	//NSString *data=[chatterList objectAtIndex:indexPath.row];
}

/*
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
	return @"참여자목록";
}
*/

- (void)dealloc {
	[chatterList release];
	[array release];
    [super dealloc];
}


@end

