//
//  ClubChatChatViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 05. 26.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatChatViewController.h"
#import "ClubChatData.h"

@implementation ClubChatChatViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	[segmentedControl addTarget:self
						 action:@selector(action:)
			   forControlEvents:UIControlEventValueChanged];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMsg:) name:@"receiveMsg" object:nil];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMemoCount:) name:@"ReceiveMemoCountNotification" object:nil];
}

-(void)action:(UISegmentedControl *)event{
	
	if(event.selectedSegmentIndex==0){
		NSLog(@"ClubChatChatView 0");
		[contentView addSubview:chatRoomListViewController.view];
		
		[chatRoomListViewController viewWillAppear:NO];
		[buddyViewController		viewDidDisappear:NO];
		[receiveMemoViewController	viewDidDisappear:NO];
		[changeNameViewController	viewDidDisappear:NO];
		
	}else if(event.selectedSegmentIndex==1){
		NSLog(@"ClubChatChatView 1");
		[contentView addSubview:buddyViewController.view];
		
		[chatRoomListViewController viewDidDisappear:NO];
		[buddyViewController		viewWillAppear:NO];
		[receiveMemoViewController	viewDidDisappear:NO];
		[changeNameViewController	viewDidDisappear:NO];
		
	}else if(event.selectedSegmentIndex==2){
		NSLog(@"ClubChatChatView 2");
		[contentView addSubview:receiveMemoViewController.view];
		
		[chatRoomListViewController viewDidDisappear:NO];
		[buddyViewController		viewDidDisappear:NO];
		[receiveMemoViewController	viewWillAppear:NO];
		[changeNameViewController	viewDidDisappear:NO];
		
	}else if(event.selectedSegmentIndex==3){
		NSLog(@"ClubChatChatView 3");
		[contentView addSubview:changeNameViewController.view];
		
		[chatRoomListViewController viewDidDisappear:NO];
		[buddyViewController		viewDidDisappear:NO];
		[receiveMemoViewController	viewDidDisappear:NO];
		[changeNameViewController	viewWillAppear:NO];
		
	}
}
//메세지전송..
-(void)sendMsgWithHeader:(NSString *)header andWithMsg:(NSString *)msg{
	NSMutableArray *array=[[NSMutableArray alloc] init];
	[array addObject:msg];
	
	ClubChatData *data=[[ClubChatData alloc] initWithHeader:header andWithArray:array];
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
	
	[array release];
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
	
	NSLog(@"viewWillAppear");
	
	chatRoomListViewController	=[[ClubChatChatRoomViewController		alloc] initWithNibName:@"ClubChatChatRoomViewController"	bundle:nil];
	buddyViewController			=[[ClubChatBuddyViewController			alloc] initWithNibName:@"ClubChatBuddyViewController"		bundle:nil];
	receiveMemoViewController	=[[ClubChatReceiveMemoViewController	alloc] initWithNibName:@"ClubChatReceiveMemoViewController"	bundle:nil];
	changeNameViewController	=[[ClubChatChangeNameViewController		alloc] initWithNibName:@"ClubChatChangeNameViewController"	bundle:nil];
	
	[changeNameViewController	viewWillAppear:animated];
	[buddyViewController		viewWillAppear:animated];
	[receiveMemoViewController	viewWillAppear:animated];
	[changeNameViewController	viewWillAppear:animated];
	
	[self action:segmentedControl];
}
- (void)viewDidAppear:(BOOL)animated {
	[super viewDidAppear:animated];
	
	[changeNameViewController	viewDidAppear:animated];
	[buddyViewController		viewDidAppear:animated];
	[receiveMemoViewController	viewDidAppear:animated];
	[changeNameViewController	viewDidAppear:animated];
}
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
	
	[changeNameViewController	viewWillDisappear:animated];
	[buddyViewController		viewWillDisappear:animated];
	[receiveMemoViewController	viewWillDisappear:animated];
	[changeNameViewController	viewWillDisappear:animated];
}
- (void)viewDidDisappear:(BOOL)animated {
	[super	viewDidDisappear:animated];
	
	[changeNameViewController	viewDidDisappear:animated];
	[buddyViewController		viewDidDisappear:animated];	
	[receiveMemoViewController	viewDidDisappear:animated];
	[changeNameViewController	viewDidDisappear:animated];
}
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

-(void)receiveMsg:(NSNotification *)notification{
	//ClubChatData *data=(ClubChatData *)notification.object;
	//if([data.header isEqualToString:@"/퇴장승인"]){
		//[self.navigationController popViewControllerAnimated:YES];
	//}
}
-(void)receiveMemoCount:(NSNotification *)notification{
	NSString *memoCount=notification.object;
	[segmentedControl setTitle:[NSString stringWithFormat:@"쪽지 %@건",memoCount] forSegmentAtIndex:2];
	
	NSLog(@"쪽지숫자받았다 : %@개",memoCount);
}
- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	
	[chatRoomListViewController	release];
	[buddyViewController		release];
	[receiveMemoViewController	release];
	[changeNameViewController	release];
	
	[segmentedControl	release];
	[contentView		release];
    [super				dealloc];
}


@end
