//
//  ClubChatReceiveMemoViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 05. 26.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatReceiveMemoViewController.h"
#import "ClubChatReceiveMemoTableCellViewController.h"
#import "ClubChatData.h"

@implementation ClubChatReceiveMemoViewController

/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/

- (void)viewDidLoad {
    [super viewDidLoad];
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
	memoList=[[NSMutableArray alloc] init];
	controllerList=[[NSMutableArray alloc] init];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMsg:) name:@"receiveMsg" object:nil];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(selectDeleteMemo:) name:@"SelectDeleteMemoNotification" object:nil];
}

///쪽지|sss|dddddd
-(void)receiveMsg:(NSNotification *)notification{
	ClubChatData *data=(ClubChatData *)notification.object;
	if([data.header isEqualToString:@"/쪽지"]){
		[memoList addObject:data.array];
		[self.tableView reloadData];
		
		//현재 쪽지숫자를 통지한다.
		NSLog(@"현재쪽지숫자를 통지한다...%d",[memoList count]);
		[[NSNotificationCenter defaultCenter] postNotificationName:@"ReceiveMemoCountNotification" object:[NSString stringWithFormat:@"%d",[memoList count]]];
		
	}
}

-(void)selectDeleteMemo:(NSNotification *)notification{
	NSString *tmpNumber=(NSString *)notification.object;
	int number=[tmpNumber intValue];
	[memoList removeObjectAtIndex:number];
	
	[self.tableView reloadData];
	
	//현재 쪽지숫자를 통지한다.
	[[NSNotificationCenter defaultCenter] postNotificationName:@"ReceiveMemoCountNotification" object:[NSString stringWithFormat:@"%d",[memoList count]]];
}

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
	
	for(ClubChatReceiveMemoTableCellViewController *controller in controllerList){
		[controller viewDidDisappear:animated];
	}
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [memoList count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	
	ClubChatReceiveMemoTableCellViewController *controller;
	UIView *view;
	if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
		
		cell.selectionStyle=UITableViewCellSelectionStyleNone;
		
		controller=[[ClubChatReceiveMemoTableCellViewController alloc] initWithNibName:@"ClubChatReceiveMemoTableCellViewController" bundle:nil];
		[controller.view setFrame:CGRectMake(8.0,8.0,304.0,200.0)];
		[controller.view setTag:1];
		
		[cell.contentView addSubview:controller.view];
		[controllerList addObject:controller];
	}
    // Set up the cell...
	NSArray *memoArray=[memoList objectAtIndex:indexPath.row];
	
	view=[cell viewWithTag:1];
	controller=(ClubChatReceiveMemoTableCellViewController *)[view nextResponder];
	[controller receiveNumber:indexPath.row sender:[memoArray objectAtIndex:0] memo:[memoArray objectAtIndex:1]];	
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
}

//삭제..
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath{
	
	[tableView deleteRowsAtIndexPaths:indexPath withRowAnimation:UITableViewRowAnimationFade];
	[tableView reloadData];
}
/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	
	[controllerList release];
	[memoList release];
    [super dealloc];
}


@end

